#include "testlib.h"
#include <vector>

using namespace std;

void encode() {
    long long n = inf.readLong();
    int mx = inf.readInt();

    // give to participant
    println(1, n);
    cout.flush();

    // collect answer
    string s = ouf.readToken("[01]+");
    int limit = (int) (sqrt(2) * ceil(log2(n)) + 5);
    if ((int) s.size() > limit) {
        quitf(_wa, "data string is too long: %u > %d", s.size(), limit);
    }

    // log to tout
    tout << 2 << ' ' << mx << ' ' << s << '\n';

    quit(_ok, "encoded");
}

void decode() {
    int mx = inf.readInt();
    string s = inf.readToken();
    unsigned int sz = s.size();

    while ((int) s.size() < mx) {
        s.push_back((char) rnd.next('0', '1'));
    }

    // give to participant
    println(2, s);
    cout.flush();

    // collect answers
    long long result = ouf.readLong();

    // log to tout
    tout << -1 << ' ' << result << ' ' << sz << ' ' << s << '\n';

    quit(_ok, "restored");
}

int main(int argc, char *argv[]) {

    registerInteraction(argc, argv);

    int _run = inf.readInt();
    if (_run == 1) encode();
    else decode();

}
