#include "testlib.h"
#include "random"

using ll = long long;

using namespace std;

int get(int from, int to) {
    return rnd.next(from, to);
}

static const int MAXN = 500'000, MAX_TESTS = 50;

int get(int x) {
    vector<int> primes{2, 3, 5, 7, 11, 13, 17};
    int ans = 0;
    for (int p: primes) {
        int delta = 0;
        while (delta + 1 < p && ++ans && x % p) {
            x--;
            delta++;
        }
    }
    return ans;
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int min_val = has_opt("min_val") ? opt<int>("min_val") : 1;
    int max_val = has_opt("max_val") ? opt<int>("max_val") : MAXN;
    int rand = has_opt("rand") ? opt<int>("rand") : 0;
    int min_reqs = has_opt("min_reqs") ? opt<int>("min_reqs") : 1;
    int max_reqs = has_opt("max_reqs") ? opt<int>("max_reqs") : 51;

    vector<int> answer;

    if (rand) {
        int sum = 0;
        int cur = get(min_val, max_val);
        while (answer.size() < MAX_TESTS && sum + cur <= MAXN) {
            answer.push_back(cur);
            sum += cur;
            cur = get(min_val, max_val);
        }
    } else {
        vector<int> funny;
        for (int i = 0; i <= MAXN; i++) {
            int g = get(i);
            if (min_reqs <= g && g <= max_reqs) {
                funny.push_back(i);
            }
        }
        int sum = 0;
        int cur = funny[get(0, static_cast<int>(funny.size()) - 1)];
        while (sum + cur <= MAXN) {
            answer.push_back(cur);
            sum += cur;
            cur = funny[get(0, static_cast<int>(funny.size()) - 1)];
        }
    }

    cout << answer.size() << '\n';
    for (auto i: answer) {
        cout << i << '\n';
    }
}
