#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "testlib.h"

using namespace std;

typedef long long ll;

const int MAX_L = 1000000000;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    const int max_n = opt<int>("n");
    const int max_m = opt<int>("m");
    const bool gen_rand = opt<bool>("r");
    const bool gen_ok = !opt<bool>("b");

    int n = max_n;
    int m = max_m;
    int k;
    if (gen_rand) {
        n = rnd.next(3, max_n);
        k = 1 + rnd.wnext(n - 2, opt<int>("kw"));
        m = rnd.next(1, (int) min((ll)max_m, (ll) n * ll(n-1) / 2) - (gen_ok ? k : 0));
    } else {
        k = opt<int>("k");
    }

    auto a = rnd.distinct(k, 2, n - 1);
    set<int> a_set(a.begin(), a.end());

    vector<pair<int, int>> edges = {{1, n}};
    set<pair<int, int>> edgesset(edges.begin(), edges.end());
    if (!gen_ok && rnd.next(0, 1)) {
        edges.emplace_back(rnd.any(a), n);
        edgesset.insert(edges.back());
    } else if (!gen_ok) {
        edges.emplace_back(n, rnd.any(a));
        edgesset.insert(edges.back());
    }

    while (edges.size() < m) {
        int u = rnd.next(1, n);
        int v = rnd.next(1, n);
        if (gen_ok && (v == n && a_set.count(u) || u == n && a_set.count(v))) {
            continue;
        }
        if (u != v && edgesset.find(make_pair(u, v)) == edgesset.end() && edgesset.find(make_pair(v, u)) == edgesset.end()) {
            edges.emplace_back(u, v);
            edgesset.emplace(u, v);
        }
    }

    println(n, m, k);
    for (int i = 0; i < k; ++i) {
        if (i > 0) {
            printf(" ");
        }
        printf("%d", a[i]);
    }
    printf("\n");

    for (auto e : edges) {
        println(e.first, e.second);
    }

    return 0;
}
