#include <functional>
#include <algorithm>
#include "testlib.h"

using namespace std;

const int max_n = 1'00'000;
const int max_m = 2'00'000;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    long long n = inf.readInt(3, max_n, "n");
    inf.readSpace();
    int m = inf.readInt(1, (int) min(n * (n - 1) / 2, (long long) max_m), "m");
    inf.readSpace();
    int k = inf.readInt(1, (int) n - 2, "k");
    inf.readEoln();

    auto a = inf.readInts(k, 2, (int) n - 1, "a");
    ensuref(set<int>(a.begin(), a.end()).size() == k, "all a_i should be different");
    inf.readEoln();

    set<pair<int, int>> edges;
    for (int i = 0; i < m; ++i) {
        int u = inf.readInt(1, (int) n, "u");
        inf.readSpace();
        int v = inf.readInt(1, (int) n, "v");
        inf.readEoln();

        ensuref(u != v, "should not be edge %d itself", v);
        ensuref(edges.find(make_pair(u, v)) == edges.end(), "edge %d - %d already was", u, v);
        ensuref(edges.find(make_pair(v, u)) == edges.end(), "edge %d - %d already was", u, v);
        edges.emplace(u, v);
    }
    ensuref(edges.find(make_pair(1, n)) != edges.end(), "should be edge from 1 to n");

    inf.readEof();
}