#include "testlib.h"
#include "random"

using ll = long long;

using namespace std;

int get(int from, int to) {
    return rnd.next(from, to);
}

int gen_between(int from, int to, int div) {
    int a = from / div;
    if (from % div) {
        a++;
    }
    int b = to / div;
    return get(a, b) * div;
}

static const int MAXN = 3'000;

vector<vector<bool>> gen_all(int mx_size) {
    vector<vector<bool>> answer;
    for (int len = 1; len <= mx_size; len++) {
        int max_mask = (1 << len);
        for (int mask = 0; mask < max_mask; mask++) {
            vector<bool> cur_data;
            int copy = mask;
            for (int j = 0; j < len; j++) {
                cur_data.push_back(copy % 2 == 0);
                copy /= 2;
            }
            answer.push_back(cur_data);
        }
    }
    return answer;
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    int min_val = has_opt("min_val") ? opt<int>("min_val") : 1;
    int max_val = has_opt("max_val") ? opt<int>("max_val") : MAXN;
    int repeat_base = has_opt("repeat") ? opt<int>("repeat") : -1;

    vector<vector<bool>> answer;

    if (repeat_base == -1 && max_val <= 7) {
        answer = gen_all(max_val);
    } else if (repeat_base != -1) {
        if (repeat_base <= 7 && (2 << repeat_base) * max_val <= MAXN) {
            answer = gen_all(repeat_base);
            for (auto &i: answer) {
                int sz = i.size(), times = (max_val / sz - 1) * sz;
                while (times--) {
                    i.push_back(i[i.size() - sz]);
                }
            }
        } else {
            int cur_sum = 0;
            int cur = gen_between(min_val, max_val, repeat_base);
            while (cur_sum + cur <= MAXN) {
                vector<bool> t;
                for (int i = 0; i < repeat_base; i++) {
                    t.push_back(get(0, 1) == 0);
                }
                int times = cur - repeat_base;
                while (times--) {
                    t.push_back(t[t.size() - repeat_base]);
                }
                answer.push_back(t);
                cur_sum += cur;
                cur = gen_between(min_val, max_val, repeat_base);
            }
        }
    } else {
        int cur_sum = 0;
        int cur = get(min_val, max_val);
        while (cur_sum + cur <= MAXN) {
            vector<bool> t;
            for (int i = 0; i < cur; i++) {
                t.push_back(get(0, 1) == 0);
            }
            answer.push_back(t);
            cur_sum += cur;
            cur = get(min_val, max_val);
        }
    }

    cout << answer.size() << '\n';
    for (auto &i: answer) {
        cout << i.size() << '\n';
        for (int j = 0; j < static_cast<int>(i.size()) - 1; j++) {
            cout << (i[j] ? 1 : 0) << ' ';
        }
        cout << i.back() << '\n';
    }
}
