#include <bits/stdc++.h>

using namespace std;

struct edge {
    int from;
    int to;
    int w;
};

int const N = 1234567;
int known[N];
vector<edge> edges[N];
int deg[N], q[N], ans[N];
int nt;


void addedge(int to, int l, int r) {
    l += nt;
    r += nt;
    while (l <= r) {
        if ((l & 1) == 1) {
            edges[l].push_back({l, to, 0});
            ++l;
        }
        if ((r & 1) == 0) {
            edges[r].push_back({r, to, 0});
            --r;
        }
        l >>= 1;
        r >>= 1;
    }
}

int main() {
    int n, s, m;
    scanf("%d%d%d", &n, &s, &m);    
    for (int i = 0; i < n; i++) known[i] = -1;
    for (int i = 0; i < s; i++) {
        int x, y;
        scanf("%d%d", &x, &y);
        --x;
        known[x] = y;
    }
    nt = 1;
    while (nt < n) nt <<= 1;
    for (int i = 2; i < nt * 2; i++)
        edges[i].push_back({i, i >> 1, 0});
    int shiftQ = nt * 2;
    for (int i = 0; i < m; i++) {
        int l, r;
        scanf("%d%d", &l, &r);
        --l;
        --r;
        int k;
        scanf("%d", &k);
        for (int j = 0; j < k; j++) {
            int id;
            scanf("%d", &id);
            --id;
            if (l <= id - 1)
                addedge(i + shiftQ, l, id - 1);
            edges[i + shiftQ].push_back({i + shiftQ, id + nt, 1});
            l = id + 1;
        }
        if (l <= r)
            addedge(i + shiftQ, l, r);
    }
    int head = 0;
    int tail = 0;
    int nv = m + shiftQ;
    for (int i = 0; i < nv; i++) deg[i] = 0;
    for (int i = 0; i < nv; i++) 
        for (edge & e : edges[i])
            deg[e.to]++;
    for (int i = 0; i < nv; i++) {
        if (deg[i] == 0) {
            q[tail++] = i;
        }
    }
    while (head < tail) {
        int v = q[head++];
        for (edge & e : edges[v]) {
            --deg[e.to];
            if (deg[e.to] == 0) {
                q[tail++] = e.to;
            }
        }
    }
    if (head != nv) {
        puts("NO");
        return 0;
    }
    for (int it = 0; it < nv; it++) {
        int i = q[it];
        if (ans[i] < 1) ans[i] = 1;
        if (i >= nt && i - nt < n) {
            int j = known[i - nt];
            if (j >= 0) {
                if (ans[i] > j) {
                    puts("NO");
                    return 0;
                }
                if (ans[i] < j) ans[i] = j;
            }
        }
        for (edge & e : edges[i]) {
//            printf("%d %d %d\n", e.from, e.to, e.w);
            ans[e.to] = max(ans[e.to], ans[i] + e.w);
        }
    }
    for (int i = 0; i < n; i++) {
        int id = i + nt;
        if (ans[id] > 1000000000 || ans[id] < 1) {
            puts("NO");
            return 0;
        }
    }
    puts("YES");
    for (int i = 0; i < n; i++) {
        int id = i + nt;
        if (i > 0) putchar(' ');
        printf("%d", ans[id]);
    }    
    puts("");
    return 0;
}
