#include "bits/stdc++.h"
#include "testlib.h"

using namespace std;

vector<int> tree_gen(int n) {
    vector<int> p(n, -1);
    for (int i = 1; i < n; ++i) {
        p[i] = rnd.next(0, i - 1);
    }
    return p;
}

void print_tree(vector<int> v) {
    for (int i = 1; i < v.size(); ++i) {
        cout << v[i] + 1 << " \n"[i == v.size() - 1];
    }
}

void dfs(int i, int p, vector<vector<int>>& v, vector<int>& d) {
    for (auto j : v[i]) {
        if (j == p) continue;

        dfs(j, i, v, d);
        d[i] = max(d[i], d[j] + 1);
    }
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = has_opt("n") ? opt<int>("n") : (int)1e5;
    int q = has_opt("q") ? opt<int>("q") : (int)2e5;
    int max_n = has_opt("max_q") ? opt<int>("max_q") : (int)n;
    int no_zero = has_opt("no_zero") ? opt<int>("no_zero") : 0;

    vector<int> tv(n, -1);

    for (int i = 1; i < n; ++i) {
        tv[i] = rnd.next(max(0, i - 5), i - 1);
    }

    println(n, q);
    print_tree(tv);

    if (no_zero) {
        vector<vector<int>> v(n);
        for (int i = 0; i < n; ++i) {
            if (tv[i] == -1) continue;
            v[i].push_back(tv[i]);
            v[tv[i]].push_back(i);
        }

        vector<int> d(n, 0);
        dfs(0, -1, v, d);

        while (q--) {
            int a = rnd.next(1, max_n);
            println(a, rnd.next(0, d[a - 1]));
        }
    } else {
        while (q--) {
            println(rnd.next(1, n), rnd.next(0, n - 1));
        }
    }
}
